package com.banesco.module.correspondence.infrastructure.client;

import com.banesco.common.application.usecase.HttpClientUseCase;
import com.banesco.common.domain.exception.HttpApiResponseException;
import com.banesco.common.domain.exception.HttpStatusCodeException;
import com.banesco.common.domain.model.ApiResponse;
import com.banesco.common.domain.model.BusinessConfig;
import com.banesco.common.domain.model.HttpRequest;
import com.banesco.common.infrastructure.config.RestClientConfig;
import com.banesco.module.correspondence.application.usecase.BusinessUseCase;
import com.banesco.module.correspondence.domain.dto.request.CorrespondenceRequest;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.inject.Inject;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ApplicationScoped
public class BusCorrespondenceClient implements BusinessUseCase {
    private final HttpClientUseCase httpClientUseCase;
    private final BusinessConfig businessConfig;

    @Inject
    public BusCorrespondenceClient(
        HttpClientUseCase httpClientUseCase,
        RestClientConfig restClientConfig
    ) {
        this.httpClientUseCase = httpClientUseCase;
        this.businessConfig = restClientConfig.getBusLegalCustomerConfig();
        log.info("Configuracion cargada para bus-create-security-notification: {}", businessConfig);
    }

    @Override
    public <T> ApiResponse<T> execute(
        CorrespondenceRequest params,
        Class<T> responseType
    ) {
        String recipientId = params.getRecipientId();
        HttpRequest request = HttpRequest.forApiResponse(
                businessConfig.getUrl(),
                HttpRequest.HttpMethod.POST,
                responseType
            )
            .withBody(params)
            .withTimeout(
                businessConfig.getTimeout().getConnect(),
                businessConfig.getTimeout().getResponse()
            );

        log.debug("Request configurado: {}", request);

        try {
            ApiResponse<T> response = httpClientUseCase.execute(request);

            log.info(
                "Solicitud del api de negocio exitoso: {}",
                response.getStatusResponse()
            );

            return response;
        } catch (HttpApiResponseException e) {
            log.error(
                "Error HTTP con ApiResponse consultando transaccion {}: {}",
                recipientId,
                e.getApiResponse()
            );

            throw new HttpStatusCodeException(
                e.getStatusCode(),
                e.getApiResponse().getStatusResponse().getStatusCode()
            );
        } catch (HttpStatusCodeException e) {
            log.error(
                "Error HTTP consultando transaccion {}: {} - {}",
                recipientId,
                e.getStatusCode(),
                e.getMessage()
            );

            throw e;
        } catch (Exception e) {
            log.error("Error consultando transaccion {}: {}", recipientId, e.getMessage());
            throw HttpStatusCodeException.serviceUnavailable("503");
        }
    }
}